package com.zhongzheng.modules.exam.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.exam.bo.ExamBeforeUrlAddBo;
import com.zhongzheng.modules.exam.bo.ExamBeforeUrlQueryBo;
import com.zhongzheng.modules.exam.bo.ExamBeforeUrlEditBo;
import com.zhongzheng.modules.exam.domain.ExamBeforeUrl;
import com.zhongzheng.modules.exam.mapper.ExamBeforeUrlMapper;
import com.zhongzheng.modules.exam.vo.ExamBeforeUrlVo;
import com.zhongzheng.modules.exam.service.IExamBeforeUrlService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 前培urlService业务层处理
 *
 * @author ruoyi
 * @date 2021-12-07
 */
@Service
public class ExamBeforeUrlServiceImpl extends ServiceImpl<ExamBeforeUrlMapper, ExamBeforeUrl> implements IExamBeforeUrlService {

    @Override
    public ExamBeforeUrlVo queryById(Long beforeUrlId){
        ExamBeforeUrl db = this.baseMapper.selectById(beforeUrlId);
        return BeanUtil.toBean(db, ExamBeforeUrlVo.class);
    }

    @Override
    public List<ExamBeforeUrlVo> queryList(ExamBeforeUrlQueryBo bo) {
        LambdaQueryWrapper<ExamBeforeUrl> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getUrlStatus() != null, ExamBeforeUrl::getUrlStatus, bo.getUrlStatus());
        lqw.like(StrUtil.isNotBlank(bo.getUrlName()), ExamBeforeUrl::getUrlName, bo.getUrlName());
        lqw.eq(StrUtil.isNotBlank(bo.getUrl()), ExamBeforeUrl::getUrl, bo.getUrl());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ExamBeforeUrlVo> entity2Vo(Collection<ExamBeforeUrl> collection) {
        List<ExamBeforeUrlVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ExamBeforeUrlVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<ExamBeforeUrl> page = (Page<ExamBeforeUrl>)collection;
            Page<ExamBeforeUrlVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(ExamBeforeUrlAddBo bo) {
        ExamBeforeUrl add = BeanUtil.toBean(bo, ExamBeforeUrl.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(ExamBeforeUrlEditBo bo) {
        ExamBeforeUrl update = BeanUtil.toBean(bo, ExamBeforeUrl.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(ExamBeforeUrl entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
